/* ***** BEGIN LICENSE BLOCK *****
 *   Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Thumbs Down.
 *
 * The Initial Developer of the Original Code is
 * Atte Kemppilä.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 * 
 * ***** END LICENSE BLOCK ***** */


const Cc = Components.classes;
const Ci = Components.interfaces;

const TYPE_ELEMENT_IDS =
    [[], 
     ["box_regexpSource", "row_regexpPattern", "row_regexpTemplate"], 
     ["row_script"]];

var currentType = 0;


function onLoad()
{
    stringBundle = $("stringbundle");
    $("labelColumn").style.width = _("css.labelColumn.width");
    var script = window.arguments[0].arg;
    if (script)
    {
        $("tbox_name").value = script.name;
        $("tbox_regexp").value = script.regexp;
        $("mlist_type").selectedIndex = script.type;
        $("radio_regexpSource").value = script.source;
        $("tbox_regexpPattern").value = script.pattern;
        $("tbox_regexpTemplate").value = script.template;
        $("tbox_script").value = script.script;
        currentType = script.type;
        _showTypeElements(currentType, true)
    }
}

function onTypeChange()
{
    _showTypeElements(currentType, false);
    currentType = $("mlist_type").value;
    _showTypeElements(currentType, true);
}

function insertScriptTemplate()
{
    var scriptTemplate = loadContent("chrome://thumbsdown/content/script_template.js");
    var tbox = $("tbox_script");
    tbox.value = tbox.value + scriptTemplate;
}

function onDialogAccept()
{
    try
    {
        var result = {}
        result.name = trim($("tbox_name").value);
        result.regexp = trim($("tbox_regexp").value);
        result.type = Number($("mlist_type").value);
        result.source = Number($("radio_regexpSource").value);
        result.pattern = trim($("tbox_regexpPattern").value);
        result.template = trim($("tbox_regexpTemplate").value);
        result.script = trim($("tbox_script").value);
        
        dump(result.pattern);
        
        if (result.name.length == 0) throw "error.noName";
        if (result.regexp.length == 0) throw "error.noRegexp";
        
        switch (result.type)
        {
            case 0:
                result.source = null;
                result.pattern = null;
                result.template = null;
                result.script = null;
                break;
            case 1:
                if (result.pattern.length == 0) throw "error.noPattern";
                if (result.template.length == 0) throw "error.noTemplate";
                result.script = null;
                break;
            case 2:
                if (result.script.length == 0) throw "error.noScript";
                result.source = null;
                result.pattern = null;
                result.template = null;
                break;
        }
        
        window.arguments[0].result = result;
        return true;
    }
    catch (e if (typeof(e) == "string"))
    {
        alert(_(e));
        return false;
    }
}


function _showTypeElements(type, show)
{
    var ids = TYPE_ELEMENT_IDS[type];
    for each (id in ids)
        $(id).hidden = (! show);
    if (show)
        window.sizeToContent();
}
